/******************************************************************************
 CCompilerOptions.c

				CCompilerOptions Dialog Director Class


	Copyright (C) 1985-1992  New York University
	Copyright (C) 1994 George Washington University
	 
	This file is part of the GWAdaEd system, an extension of the Ada/Ed-C
	system.  See the Ada/Ed README file for warranty (none) and distribution
	info and also the GNU General Public License for more details.

	Generated by Classy (Object Factory) 9:22 PM Thu, Aug 5, 1993

	This file is only generated once. You can modify it by filling
	in the placeholder functions and adding any new functions you wish.

	If you change the name of the dialog class, a fresh version of this
	file will be generated. If you have made any changes to the file
	with the old name, you will have to copy those changes to the new
	file by hand.

 ******************************************************************************/


#include "CCompilerOptions.h"

#include "CompilerOptionsItems.h"
//#include "AppCommands.h"			// Remove comments if DoCommand overridden

#include <CIntegerText.h>
#include <CControl.h>
#include <CPopup.h>
#include <CPopupPane.h>
#include <CArrayPane.h>
#include <CIconButton.h>
#include <CPictureButton.h>
#include <CSwissArmyButton.h>

#include <CApplication.h>
#include <Constants.h>
#include <CDecorator.h>
#include <CDesktop.h>
#include <CDirectorOwner.h>
#include <CFile.h>
#include <TBUtilities.h>
#include <CWindow.h>

#include "CAdaApp.h"

extern	CApplication *gApplication;		/* The application					*/
extern CDecorator	*gDecorator;		/* Decorator for arranging windows	*/
extern CDesktop		*gDesktop;			/* The visible Desktop				*/


/**** C O N S T R U C T I O N / D E S T R U C T I O N   M E T H O D S ****/


/******************************************************************************
 ICCompilerOptions

	Initialize the dialog

	IMPORTANT NOTE: When an object is initialized as part of a
	'CVue' resource, this I-function is NEVER CALLED. Instead,
	the object is initialized in its GetFrom method(s). To add your
	own initialization, override GetFrom.

 ******************************************************************************/

void CCompilerOptions::ICCompilerOptions(CDirectorOwner *aSupervisor)

{
		// Initialize data members that must be set up before
		// BeginData is called here

	x_CCompilerOptions::Ix_CCompilerOptions(aSupervisor);

		// Initialize any other data members here

}


/******************************************************************************
 BeginData

	Set up initial pane values
******************************************************************************/

void CCompilerOptions::BeginData(CCompilerOptionsData *initial)
{
	Boolean lib, lis;
	 	//	Superclass calls BeginData once after the window is created
	 	//	to gather the initial values for the dialog panes. Note that
	 	//	BeginData is called *before* Ix_CCompilerOptions returns. If you
	 	//	do not override this function, all values are initially
	 	//	zero or null.

	((CAdaApp *)gApplication)->GetOptions(&lis);

	if (lis == openListingAlways) {
		initial->fCompilerOptions_Always = 1;
		initial->fCompilerOptions_Errors = 0;
	}
	else {
		initial->fCompilerOptions_Always = 0;
		initial->fCompilerOptions_Errors = 1;
	}
}


/******************************************************************************
 UpdateData
 
 	React to changes by the user (or the program)
******************************************************************************/

void CCompilerOptions::UpdateData(CCompilerOptionsUpdate *update, long itemNo)

{
		//	UpdateData is called every time the user or the program
		//	changes the value of a dialog pane. (Changes you make to
		//	panes during a call to UpdateData do not result in
		//	recursive calls to UpdateData.)

		//	Override to dynamically update other program objects.
		//	Note that *only* the value corresponding to itemNo is present in
		//	the update record. If you need the values of other panes,
		//	you must ask the panes for them.
}


/******************************************************************************
 EndData
 
 	Receive final values from the dialog
******************************************************************************/

void CCompilerOptions::EndData(CCompilerOptionsData *final)

{
		//	The values of all panes are returned by this function,
		//	which is called just before Close for a modeless dialog,
		//	or just before returning from DoModalDialog.
		
		//	If DoModalDialog returns cmdCancel, EndData is called
		//	with the values initially supplied to BeginData, allowing
		//	you to back out any intermediate changes made in response
		//	to UpdateData. If you do not use UpdateData, you can
		//	test the value of dismissCmd to see whether to respond
		//	to EndData.

	if (dismissCmd != cmdCancel) {

		if (final->fCompilerOptions_Always == 1)
			((CAdaApp *)gApplication)->SetOptions(openListingAlways);
		else
			((CAdaApp *)gApplication)->SetOptions(openListingOnError);
	}
}


/******************************************************************************
 ProviderChanged	{OVERRIDE}
 	
 	A pane changed value
******************************************************************************/

void CCompilerOptions::ProviderChanged(CCollaborator *aProvider, long reason, void* info)

{
		//	Override this function if you need to respond more directly
		//	to changes in pane values. See the superclass's ProviderChanged
		//	function for an example of how to check for changes.

		//	Note that there is a lot of traffic through this function
		//	in addition to change notices. Do not forget to call the
		//	superclass for all changes you do not handle completely.

	x_CCompilerOptions::ProviderChanged(aProvider, reason, info);
}


/******************************************************************************
 DoCommand {OVERRIDE}

		Dispatch commands
 ******************************************************************************/

void CCompilerOptions::DoCommand(long theCommand)

{
	switch (theCommand)
	{
			// Insert your command handler cases here, e.g.,
			//
			//	case cmdMine:
			//		DoMyCmd();
			//		break;

		default:
			x_CCompilerOptions::DoCommand(theCommand);
	}
}
